#! /bin/csh -f
# Script for testing r8tohdf 
#
# Input files needed: storm110.raw (an 8-bit raw raster image file) 
#                     palette.raw   (any raw palette file)
#                     storm120.raw
#                     storm130.raw
#
# Output files: o1 through o8 (see actual commands for their contents)
#
# The dimensions in the input files are assumed to be 57x57.
#
# Output files can be examined with hdfls to see if basic
# contents are there.  Display the images using any HDF
# 8-bit raster display tool.
# 
# 
# Not tested: multiple input files with different options for each.
#             imcomp compression (a bug has been found that sometimes
#                   causes imcomp compression to loop infinitely)
#
set echo
#
# convert image with no compression (default), no palette
r8tohdf 57 57 o1.hdf storm110.raw
#
# convert image with no compression (-r), with palette
r8tohdf 57 57 o2.hdf -p palette.raw -r storm110.raw
#
# convert image with rle compression, no palette
r8tohdf 57 57 o3.hdf -c storm110.raw
#
# convert image with rle compression, with palette
r8tohdf 57 57 o4.hdf -p palette.raw -c storm110.raw
#
# convert three images with no compression, no palette
r8tohdf 57 57 o5.hdf storm110.raw storm120.raw storm130.raw
#

unset echo


